SystemOrganization addCategory: #'Rizel-Roassal-Views'!

Object subclass: #RzVisualizer
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer class methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizer methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!RzVisualizer methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	owner := t1! !

!RzVisualizer methodsFor: 'as yet unclassified' stamp: ''!
visualize
	^ self! !

RzVisualizer subclass: #RzVisualizer1D
	instanceVariableNames: 'yAxis label factor gap values padding height xAxis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
factor
	^ factor! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
factor: t1 
	factor := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
gap
	^ gap! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
gap: t1 
	gap := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
height
	^ height! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
height: t1 
	height := t1! !

!RzVisualizer1D methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	factor := 2.
	gap := 40.
	yAxis := OrderedCollection new.
	yAxis := OrderedCollection new.
	padding := 50.
	height := 200.
	label := [:t1 | t1 printString]! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
label
	^ label! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
label: t1 
	label := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 22:43'!
max
	^ values
		maxValue: [:v | yAxis
				maxValue: [:y | y value: v]].! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 22:42'!
min
	|max|
	max := self max.
	^ self min: values value: [ :v |
		self min: yAxis value:[ :y | y value: v] max: max.
		 ]  max: max.! !

!RzVisualizer1D methodsFor: 'util' stamp: 'JuanPabloSandovalA 6/9/2012 22:40'!
min: aCollection  value: aBlock max: maxValue
	|min|
	min := maxValue.
	aCollection do:[ :obj|
		|val|
		val :=(aBlock value: obj).
		val < min ifTrue:[ min:=val.].].
	
	^ min.
	
! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
padding
	^ padding! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
padding: t1 
	padding := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
values
	^ values! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
values: t1 
	values := t1! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:10'!
visualize
	"open a window"
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeOn: view.
	view open! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:10'!
visualizeOn: view
	"roassal scripts"
	self visualizeYAxisOn: view.
	self visualizeXAxisOn: view.
	self visualizeValuesOn: view.
	view scatterPlotLayout x: #x; y: #y! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:09'!
visualizeValuesOn: view
	"visualizing values"
	view shape rectangle width: factor + gap * values size; height: self height.
	view node: (RzDummy x: padding + factor + gap y: factor + gap)
			forIt: [
				| diff max min |
				max := self max.
				min := self min.
				diff := max - min + 1.
				yAxis do: [:y | 
					| xo last |
					xo := factor.
					values do: [:profile | 
						| current |
						view shape rectangle width: factor;
							 height: factor.
						current := RzDummy
									x: xo
									y: self height - ((y value: profile) - min / diff * self height)
									model: profile.
						view node: current.
						last ifNotNilDo: [:t11 | view edgeFromAssociation: last -> current].
						last := current.
						xo := xo + factor + gap]].
				view scatterPlotLayout x: #x; y: #y. ].
	! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:53'!
visualizeXAxisOn: view 
	"visualize X axis"
	view shape rectangle width: factor + gap * self values size; height: factor * 2; withoutBorder.
	view node: (RzDummy x: padding + factor + gap y: self height + gap)
		forIt: [
			| xo |
			xo := factor.
			xAxis do: [:x | 
					view shape label text: [:dummy | label value: dummy model model].
					view node: (RzDummy x: xo y: gap model: x).
					xo := xo + factor + gap].
					view scatterPlotLayout x: #x; y: #y. ].! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:50'!
visualizeYAxisOn: view 
	"visualizing y axis"
	view shape rectangle  width: padding; height: self height; withoutBorder.	
	view node: (RzDummy x: factor + gap y: factor + gap)
		 forIt: [
			view shape label text: [:dummy | dummy model printString].
			view node: (RzDummy x: 0 y: 1 model: self max).
			view shape label text: [:dummy | dummy model printString].
			view node: (RzDummy x: 0 y: (self height - factor - 1) model: self min).
			view scatterPlotLayout x: #x; y: #y. ].! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
width
	^ values size! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
xAxis
	^ xAxis! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
xAxis: t1 
	xAxis := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
yAxis
	^ yAxis! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
yAxis: t1 
	yAxis add: t1! !

RzVisualizer subclass: #RzVisualizer2D
	instanceVariableNames: 'xValues yValues factor gap value padding xLabel yLabel xPopupView color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:38'!
color
	^ color.! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:50'!
color: aSymbol
	color := aSymbol.! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:39'!
colorValue: aProfile 
	""
	^ aProfile ifNil: [0] ifNotNil: [aProfile perform: color]! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
factor
	^ factor! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:42'!
factor: aNumber
	factor := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
gap
	^ gap! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:42'!
gap: aNumber
	gap := aNumber! !

!RzVisualizer2D methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	gap := 20.
	factor := 25.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	padding := 200.
	xLabel := [:t1 | t1 printString].
	yLabel := [:t1 | t1 printString].
	xPopupView := [:t1 :t2 :t3 | nil]! !

!RzVisualizer2D methodsFor: 'util' stamp: 'JuanPabloSandovalA 6/9/2012 19:34'!
min: aCollection  value: aBlock max: maxValue
	|min|
	min := maxValue.
	aCollection do:[ :obj|
		|val|
		val :=(aBlock value: obj).
		val < min ifTrue:[ min:=val.].].
	
	^ min.
	
! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
padding
	^ padding! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
padding: aNumber
	padding := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
value: aBlock
	value := aBlock! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:15'!
visualize
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeOn: view.
	view open.! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:17'!
visualizeOn: view 
	"visualizing"
	self visualizeXAxisOn: view.
	self visualizeYAxisOn: view.
	self visualizeValuesOn: view.
	view scatterPlotLayout x: #x; y: #y.! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 6/12/2012 00:46'!
visualizeValuesOn: view 
	| xo yo lastOne |
	xo := factor * 2 + gap + padding.
	yo := factor.
	yValues
		do: [:yValue | 
			| max colors min |
			max := xValues maxValue: [:xValue | self colorValue: (value value: xValue value: yValue)].
			min := self min: xValues value:[:xValue | self colorValue: (value value: xValue value: yValue)] max: max.
			colors := Color white mix: Color black shades: 105.
			lastOne := nil.
			xValues do: [:xValue | 
					| dummy profile|
					profile := value value: xValue value: yValue.
					view shape rectangle width: factor; height: factor;
						fillColor: (colors at: ((((self colorValue: profile)
									- min) / (max - min+1)) * 100) asInteger + 1).
					dummy := RzDummy x: xo y: yo model: profile.
					dummy last: lastOne.
					view interaction
						on: ROMouseEnter
						do: [:event | 
							| newest oldest | dummy hasLast
								ifTrue: [newest := view container elementFromModel: dummy last.
									oldest := view container elementFromModel: dummy.
									newest shapesDo: [:shape | shape borderColor: Color blue].
									oldest shapesDo: [:shape | shape borderColor: Color blue].
									view view signalUpdate] ].
					view interaction
						on: ROMouseLeave
						do: [:event | | newest oldest | dummy hasLast
								ifTrue: [newest := view container elementFromModel: dummy last.
									oldest := view container elementFromModel: dummy.
									newest shapesDo: [:shape | shape borderColor: Color black].
									oldest shapesDo: [:shape | shape borderColor: Color black].
									view view signalUpdate]].
					view interaction
						item: 'compare'
						action: [:d | | old new | d hasLast
								ifTrue: [new := d model.
									old := d last model.
									(RzVisualizerDiffGraph on: (Rizel new merge: old with: new)) visualize]].
					view node: dummy.
					xo := xo + gap + factor.
					lastOne := dummy].
			yo := yo + gap + factor.
			xo := factor * 2 + gap + padding]! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:21'!
visualizeXAxisOn: view
	"visualizing x axis"
	| yo xo |
	xo := padding + (2 * gap) + factor.
	yo := gap + factor + 1 * yValues size + gap.
	xValues do: [:x | 
			view shape label text: [:dummy | xLabel value: dummy model model].
			view node: (RzDummy x: xo y: yo model: x).
			xo := xo + gap + factor]! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 21:51'!
visualizeYAxisOn: view
	| xo yo |
	xo := factor.
	yo := factor.
	yValues
		do: [:yv | 
			view shape label text: [:el | yLabel value: el model model].
			view interaction
				popupView: [:t6 :t7 | 
					xPopupView
						value: yv
						value: self xValues
						value: t7].
			view node: (RzDummy x: xo y: yo model: yv).
			yo := yo + gap + factor]! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
xLabel
	^ xLabel! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
xLabel: aBlock
	xLabel := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
xPopupView
	^ xPopupView! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
xPopupView: aBlock 
	xPopupView := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
xValues
	^ xValues! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
xValues: aBlock 
	xValues := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
yLabel
	^ yLabel! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:44'!
yLabel: aBlock 
	yLabel := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
yValues
	^ yValues! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:44'!
yValues: aBlock
	yValues := aBlock! !

RzVisualizer subclass: #RzVisualizerDiff
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerDiff class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	| t2 |
	t2 := self new.
	t2 packages: t1.
	^ t2! !

!RzVisualizerDiff methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:42'!
allMethods
	| list |
	list := OrderedCollection new.
	packages
		do: [:pkg | list addAll: pkg diffMethods].
	^ list.! !

!RzVisualizerDiff methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/5/2012 23:15'!
borderColorOf: aMethod
	
	"removed"
	(aMethod newSourceCode size < 1 ) ifTrue:[ ^ Color gray].
	"added"
	(aMethod oldSourceCode size < 1 ) ifTrue:[ ^ Color yellow.].
	"modified"
	(aMethod oldSourceCode ~= aMethod newSourceCode) ifTrue:[ ^ Color red].
	"same"
	^ Color black
	! !

!RzVisualizerDiff methodsFor: 'util' stamp: 'JuanPabloSandovala 6/1/2012 14:41'!
diffColor: aNumber 
	aNumber = 0
		ifTrue: [^ Color white].
	aNumber = 1
		ifTrue: [^ Color yellow].
	aNumber = 2
		ifTrue: [^ Color orange].
	aNumber = 3
		ifTrue: [^ Color red]! !

!RzVisualizerDiff methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/5/2012 21:58'!
max: selector 
	^ (self allMethods
		collect: [:method | method newPerform: selector ifNil: 0]) max + 1! !

!RzVisualizerDiff methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/5/2012 22:06'!
maxDiff: selector 
	^ (self allMethods
		collect: [:method | method diff: selector ifNegative: 0]) max + 1! !

!RzVisualizerDiff methodsFor: 'accessing' stamp: ''!
packages
	^ packages! !

!RzVisualizerDiff methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:46'!
packages: aCollectionRzPackages
	packages := aCollectionRzPackages.! !

!RzVisualizerDiff methodsFor: 'roassal' stamp: 'JuanPabloSandovala 6/1/2012 14:41'!
visualize
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeOn: view.
	view open.! !

!RzVisualizerDiff methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:02'!
visualizeClass: rzClass on: view
	""
	|colors maxNOEC maxSize maxNOE diffMaxNOEC|
	maxNOEC := self max: #numberOfCalls.
	diffMaxNOEC := self maxDiff: #numberOfCalls.
	maxSize := 50.
	colors := Color white mix: Color red shades: 101.
	maxNOE := self maxDiff: #numberOfExecutions.
	
	view shape label.
	view node: (rzClass anyPerform:#className ifNil:['']).
	view rectangle withoutBorder.
	view node:'Methods' forIt:[
		view shape rectangle
			fillColor: [ :m| 
				| colorIndex |
				colorIndex := ((m newPerform: #numberOfCalls ifNil: 0)
							/ maxNOEC * 100) asInteger + 1.
				colors at: colorIndex
				];
			
			borderColor: [:method | self borderColorOf: method.];
			borderWidth: 2;
			width: [:method | 
				(method diff: #numberOfCalls ifNegative: 1)/ diffMaxNOEC * maxSize + 10.];
			height: [:method | 
				(method diff: #numberOfExecutions ifNegative: 1)/ maxNOE * maxSize + 10. ].
			view interaction item: 'browse' action: #browse.
			view nodes: rzClass methods.
			view horizontalLineLayout.
	].
	view verticalLineLayout.! !

!RzVisualizerDiff methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/5/2012 22:40'!
visualizeOn: view 

	view node: ProtoObject forIt: [
		view shape label.
		view nodes: #(	'Big squares are packages and classes' 
						'Small squares are methods with different source code (newest sourceCode ~= oldest sourceCode)'
						'Height is proportional to (newest numberOfExecutions - oldest numberOfExecutions)'
						'Width is proportional to (newest numberOfCalls - oldest numberOfCalls)'
						'Color is proportional to (newest numberOfCalls)'
						'Right click on a method to compare the source code ( oldest sourceCode vs newest sourceCode)').
		view verticalLineLayout
	].
	view
		nodes: packages
		forEach: [:pkg |
			self visualizePackage: pkg on: view.
			view verticalLineLayout.
			].
	view verticalLineLayout.! !

!RzVisualizerDiff methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:02'!
visualizePackage: rzPackage on: view
	view shape label.
	view node: (rzPackage anyPerform:#packageName ifNil:['']).
	view rectangle withoutBorder.
	view node: 'Classes' forIt:[
		view shape rectangle.
		view
			nodes: rzPackage classes
			forEach: [:cls | self visualizeClass: cls on: view].
		view horizontalLineLayout.
		].
	view verticalLineLayout.! !

RzVisualizer subclass: #RzVisualizerDiffGraph
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerDiffGraph class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 23:56'!
methods: ms
	|inst|
	inst := self new.
	inst methods: ms.
	^ inst.! !

!RzVisualizerDiffGraph class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 23:56'!
on: packages
	|ms|
	ms := OrderedCollection new.
	packages do:[ :p| ms addAll:(p methods).].
	^ self methods: ms.! !

!RzVisualizerDiffGraph methodsFor: 'roassal' stamp: 'JPSA 6/20/2012 23:36'!
borderColorFor: rzMethod
	"Red: different source code; Black: source code identical."
	(rzMethod hasDifferentSourceCode2) ifTrue: [ ^ Color red.].
	^ Color black.
	! !

!RzVisualizerDiffGraph methodsFor: 'roassal' stamp: 'JPSA 6/21/2012 01:49'!
colorFor: rzMethod
	"Green: method execution time is less than previous version; Red: method execution time is greater than previous version; Yellow: method was not implemented in previous version; White: method execution time is identical."
	rzMethod old  ifNil:[ ^ Color yellow.].
	rzMethod new ifNil:[ ^ Color gray.].
	(rzMethod old numberOfCalls < rzMethod new numberOfCalls and:[
		rzMethod old numberOfExecutions >= rzMethod new numberOfExecutions
		]) ifTrue:[ ^ Color lightRed].
	(rzMethod old numberOfCalls < rzMethod new numberOfCalls ) ifTrue:[ ^ Color red].
	(rzMethod old numberOfCalls > rzMethod new numberOfCalls ) ifTrue:[ ^ Color green].
	^ Color white.
	! !

!RzVisualizerDiffGraph methodsFor: 'metrics' stamp: 'JPSA 6/21/2012 01:07'!
diff: aPropertySymbol on: rzMethod
	""
	|a b|
	a := rzMethod property: aPropertySymbol from:#new ifAbsent: [ 0 ].
	b := rzMethod property: aPropertySymbol from:#old  ifAbsent: [ 0 ].
	^ (a > b) ifTrue:[ a - b] ifFalse:[ 0 ]. ! !

!RzVisualizerDiffGraph methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/10/2012 14:31'!
maxDiff: aPropertySymbol
	|max|
	max := 0.
	self methods do:[ :m |
		|diff|
		diff := self diff: aPropertySymbol on: m.
		(diff > max)ifTrue:[max:=diff]. ].
	^ max.! !

!RzVisualizerDiffGraph methodsFor: 'accessing' stamp: 'JPSA 6/21/2012 01:34'!
methods
	""
	|roots result|
	roots := methods select:#hasDifferentSourceCode.
	result := OrderedCollection new.
	result addAll: roots.
	roots do: [:root| result addAll: (root allOutgoingMethods select: [ :m | m hasDifferent: #numberOfCalls])].
	
	result addAll: (methods select:[ :m | (m hasDifferent: #numberOfCalls)]).
	
	^ result asSet.		
	 "select:[ :m | ((m hasDifferent:#numberOfCalls) 
							or: [m hasDifferent:#executionTime ])
							or: [m hasDifferent: #copySourceCode]]."! !

!RzVisualizerDiffGraph methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 12:42'!
methods: anObject

	methods := anObject! !

!RzVisualizerDiffGraph methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/10/2012 14:31'!
minDiff: aPropertySymbol
	|min|
	min := self maxDiff: aPropertySymbol.
	self methods do:[ :m |
		|diff|
		diff := self diff: aPropertySymbol on: m.
		(diff < min)ifTrue:[min:=diff]. ].
	^ min.! !

!RzVisualizerDiffGraph methodsFor: 'roassal' stamp: 'JPSA 6/21/2012 01:02'!
visualize
	|view|
	view := MOViewRenderer new.
	self visualizeOn: view.
	view open.! !

!RzVisualizerDiffGraph methodsFor: 'roassal' stamp: 'JPSA 6/21/2012 01:38'!
visualizeOn: view
	""
	|maxNOC maxNET maxSize cache|
	maxNOC := (self maxDiff: #numberOfExecutions)+1.
	maxNET  := (self maxDiff: #numberOfCalls)+1.
	maxSize := 50.
	
	view shape rectangle
					width: [ :m |  (self diff:#numberOfExecutions on: m) log * 10];
					height: [ :m |  ((self diff:#numberOfCalls on: m) log) * 10 ];
					fillColor: [ :m | self colorFor:m ];
					borderColor: [ :m | self borderColorFor:m];
					borderWidth:[:m| 1].
	view interaction item: 'browse' action: #browse.
	view interaction item: 'subGraph' action: #analize.
	cache := self methods asSet.
	view nodes: (cache).
	"view edges: (self methods)  from:#yourself toAll: [ :rzm | rzm incomingCalls]."
	view shape arrowedLine.
	view edges: (cache)  from:#yourself toAll: [ :rzm | rzm outgoingCalls.].
	view sugiyamaLayout.
	"view treeLayout."
	
	"view nodes: (cache select:[ :m| m outgoingCalls size < 1 ])."
	"view edges: (self methods)  from:#yourself toAll: [ :rzm | rzm incomingCalls]."
	"view gridLayout."! !

Object subclass: #RzVisualizerSelector
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerSelector class methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 14:47'!
owner: rizelBuilder
	owner := rizelBuilder! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 14:47'!
v1D
	| rzv |
	rzv := RzVisualizer1D owner: owner.
	owner visualizer: rzv.
	^ rzv! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 14:47'!
v2D
	| rzv |
	rzv := RzVisualizer2D owner: owner.
	owner visualizer: rzv.
	^ rzv! !
